<template>
  <div class="rui-accordion" :class="componentCSS">
    <div class="rui-accordion__header" @click="collapsed = !collapsed">
      <div class="rui-accordion__title">
        <!-- @slot Override default header (icon + text) -->
        <slot name="header">
          <rui-icon v-if="icon" :name="icon" />
          {{ caption }}
        </slot>
      </div>
      <div v-if="hasContent">{{ collapsed ? '▸' : '&blacktriangledown;' }}</div>
    </div>
    <div v-if="hasContent" v-show="!collapsed" class="rui-accordion__content">
      <!-- @slot Content -->
      <slot />
    </div>
  </div>
</template>

<script>
import RuiIcon from '../../Icon/Icon.vue'

/**
 * Component with hidden content, which shows up when clicking on it.
 *
 * This is similar to a `details` tag, without the meaning.
 *
 * @preset Default { "props": { "caption": "Click me!" }, "slots": { "default": "Content" } }
 * @propsGroup Display [noContent]
 * @propsGroup Content [caption, icon]
 */
export default {
  name: 'RuiAccordion',
  components: { RuiIcon },
  props: {
    /** Text, to use if `header` slot is not used */
    caption: { required: false, type: String, default: null },
    /** Optional icon, to use if `header` slot is not used */
    icon: { required: false, type: String, default: null },
    /**
     * Whether to force hiding content
     *
     * This is useful when default slot is defined conditionally and leaves an empty container
     */
    noContent: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      collapsed: true,
    }
  },
  computed: {
    hasContent () { return this.$slots.default && !this.noContent },
    componentCSS () {
      return [
        this.hasContent && 'rui-accordion--expandable',
      ]
    },
  },
}
</script>
